#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "QAsyncSerial.h"
#include "qextserialenumerator.h"
#include <QtDebug>
#include <QMessageBox>
#include <QFileDialog>
#include <QProgressDialog>
#include <QDir>
#include <QDate>
#include <QTimer>
#include <QTranslator>


namespace Ui
{
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    QAsyncSerial serial;
    bool isDownloadStart;
    QStringList gpsdata;
    QProgressDialog * pd;
    QTimer * t;
    QFile * m_firmware_file;
    int download_size;
    int steps;
    char m_TxBuf[255];
    int fileLen;
    bool init_serialport(int ui_baud_rate_item , int baud_rate);
    bool ReadFileLine(char *buf,int *len);

signals:
    //获取固件版本和闪存使用情况消息
    void found_ver(QString data);
    void found_mem(QString data);

    //下载gps数据消息
     void found_connect();
     void found_download(QString data);
     void found_downcomplete( );
     void downloadstart(QString data);

    //刷除闪存内的gps数据
    void found_starterase();
    void found_erasecomplete();

    //升级固件
    void upload_firmware_found_ok();
    void uplaod_firmware_found_error();
    void upload_firmware_found_ready();
    void upload_firmware_found_finish();
    void upload_firmware_send_data(int value);


private slots:
    void on_actionSolmeta_Utility_triggered();
    void on_language_comboBox_currentIndexChanged(int index);
    void on_firmware_upgrade_pushButton_clicked();
    void on_firmware_upgrade_path_pushButton_clicked();
    void on_erase_memory_pushButton_clicked();
    void on_stop_Button_clicked();
    void on_checkinfo_pushButton__clicked();
    void on_open_Button_clicked();
    void on_download_pushButton_clicked();
    void on_download_path_pushButton_clicked();

    //升级固件
    void on_upload_firmware_found_ok();
    void on_upload_firmware_found_error();
    void on_upload_firmware_found_ready();
    void on_upload_firmware_found_finish();
    void on_upload_firmware_send_data(int value);

    void on_found_ver(QString data);
    void on_found_mem(QString data);

    void on_found_connect();
    void on_found_download(QString data);
    void on_found_downcomplete( );
    void on_downloadstart(QString data);

    void on_found_starterase();
    void on_found_erasecomplete();

    //接受串口返回消息
    void onLineReceived(QString data);
};

#endif // MAINWINDOW_H
