// COM32Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "COM32.h"
#include "COM32Dlg.h"
#include "Dbt.h"

#include <string>
#include "greta\regexpr2.h"
using namespace std;
using namespace regex;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT	WM_DOWNLOADHEX		= RegisterWindowMessage(_T("SNOWOLF DOWNLOAD HEX FILE"));
UINT	WM_DOWNLOADFILE		= RegisterWindowMessage(_T("SNOWOLF DOWNLOAD GPS FILE"));

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CButtonST	m_btnVersion;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_btnVersion.SetURL(_T("http://www.solmeta.com"));
	m_btnVersion.SetColor(1,RGB(255,0,0));
	m_btnVersion.SetColor(3,RGB(0,0,255));
	
	g_SetDialogStrings(this,IDD);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_BUTTON_VERSION, m_btnVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CCOM32Dlg dialog

CCOM32Dlg::CCOM32Dlg(CWnd* pParent /*=NULL*/)
: CDialog(CCOM32Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCOM32Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_openFileFlag	= 0;
	m_nFileLen		= 0;
	m_sendErrFlag	= 0;
	m_downloadFlag	= 0;
	m_downFileOpenFlag	= 0;
	m_downFileStartFlag	= false;
	m_strPath.Empty();
}

void CCOM32Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCOM32Dlg)
	DDX_Control(pDX, IDC_COMBO_LANGUAGE, m_cmbLang);
	DDX_Control(pDX, IDC_COMBO_BANDRATE, m_bandRate);
	DDX_Control(pDX, IDC_BTN_COMSTOP, m_btn_comstop);
	DDX_Control(pDX, IDC_BTN_COMSTART, m_btn_comstart);
	DDX_Control(pDX, IDC_COMLIST, m_cmb_comlist);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCOM32Dlg, CDialog)
	//{{AFX_MSG_MAP(CCOM32Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_COMSTART, OnBtnComstart)
	ON_BN_CLICKED(IDC_BTN_COMSTOP, OnBtnComstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_DOWNLOAD, OnButtonDownload)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_DATA, OnButtonBrowseData)
	ON_BN_CLICKED(IDC_BUTTON_DOWNLOAD_DATA, OnButtonDownloadData)
	ON_BN_CLICKED(IDC_BUTTON_ERASE, OnButtonErase)
	ON_CBN_SELCHANGE(IDC_COMBO_BANDRATE, OnSelchangeComboBandrate)
	ON_CBN_SELCHANGE(IDC_COMLIST, OnSelchangeComlist)
	ON_BN_CLICKED(IDC_BUTTON_VER, OnButtonVer)
	ON_CBN_SELCHANGE(IDC_COMBO_LANGUAGE, OnSelchangeComboLanguage)
	//}}AFX_MSG_MAP
	ON_MESSAGE(PWM_GOTCOMMDATA,OnReceiveData)
	ON_REGISTERED_MESSAGE(WM_DOWNLOADHEX,OnDownLoadHex)
	ON_REGISTERED_MESSAGE(WM_DOWNLOADFILE,OnDownloadFile)
	ON_WM_DEVICECHANGE()	// ***For Surprise Removal Handling***
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCOM32Dlg message handlers
void CCOM32Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

BOOL CCOM32Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
//			while(pSysMenu->RemoveMenu(0,MF_BYPOSITION));
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	memset(m_szParse,0,MAX_PATH);
	memset(m_szTemp,0,MAX_PATH);

	com1=new Ccom(this->m_hWnd);
	FindCom();
// 	try{
// 		m_cmb_comlist.SetCurSel(0);
// 	}
// 	catch(...){}
	TCHAR strpath[100];
	GetCurrentDirectory(100,strpath);
	GetDlgItem(IDC_EDIT_PATH_DATA)->SetWindowText(strpath);
	m_btn_comstart.EnableWindow(TRUE);
	m_btn_comstop.EnableWindow(FALSE);
	m_bandRate.SetCurSel(0);

	LoadAllLanguage();
	g_SetDialogStrings(this,IDD);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCOM32Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCOM32Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCOM32Dlg::FindCom()
{
	//öٵǰϵͳеĴ
	LONG res = 0;
	HKEY key = NULL;
	
	res = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("HARDWARE\\DEVICEMAP\\SERIALCOMM"), 0, KEY_ALL_ACCESS, &key);
	if( res )
		return ;
	
	TCHAR keyname[MAX_PATH];
	TCHAR data[MAX_PATH];
	DWORD keynamelen = 0;
	DWORD datalen = 0;
	
	int index = 0;
	
	m_cmb_comlist.ResetContent();
	while(1)
	{
		keynamelen = MAX_PATH;
		datalen = MAX_PATH;
		memset(keyname,0,MAX_PATH);
		res = RegEnumValue(key, index++, keyname, &keynamelen, NULL, NULL, (LPBYTE)data, &datalen);
		
		if( res )
			break;
//		if(_tcsstr(keyname,_T("Silabser"))||_tcsstr(keyname,_T("slabser"))||_tcsstr(keyname,_T("Serial")))
			m_cmb_comlist.AddString(data);
	}
	try{
		m_cmb_comlist.SetCurSel(0);
	}
	catch(...){}

	RegCloseKey(key);
}

BOOL CCOM32Dlg::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	if(nEventType==DBT_DEVICEARRIVAL)
	{
		FindCom();
	}
	else if(nEventType==DBT_DEVICEREMOVECOMPLETE)	//DBT_DEVICEQUERYREMOVE
	{
		if(com1->IsOpened())
		{
			com1->StopComm();
			m_btn_comstart.EnableWindow(TRUE);
			m_btn_comstop.EnableWindow(FALSE);
		}
		FindCom();
	}
	return true;
}

void CCOM32Dlg::OnReceiveData(WPARAM w,LPARAM l)
{
	char * buff=(char*)l;
	DWORD bufsize=w;
	char resultbuff[64];	

	if(m_downloadFlag)
	{
		memset(resultbuff,0,sizeof(resultbuff));
		if(Match_Sensor(buff,"#Ver.+\n",resultbuff))
		{
			TCHAR wresultbuff[MAX_PATH];
			MultiByteToWideChar(CP_ACP,0,(char*)(resultbuff+5),-1,wresultbuff,MAX_PATH);
			GetDlgItem(IDC_STATIC_VER)->SetWindowText(wresultbuff);
		}
		if(Match_Sensor(buff,"#mem.+\n",resultbuff))
		{
			TCHAR wresultbuff[MAX_PATH];
			MultiByteToWideChar(CP_ACP,0,(char*)(resultbuff+5),-1,wresultbuff,MAX_PATH);
			GetDlgItem(IDC_STATIC_MEMINFO)->SetWindowText(wresultbuff);
		}
		if(Match_Sensor(buff,"#connect"))
		{
			OnBtnComstop();
			m_bandRate.SetCurSel(1);
			OnBtnComstart();
			m_sendErrFlag		= 0;
			this->PostMessage(WM_DOWNLOADFILE,0,0);
		}
		if(Match_Sensor(buff,"#download.+\n",resultbuff))
		{						
			if(bufsize>=9)
			{
				char lenbuf[8];
				memset(lenbuf,0,sizeof(lenbuf));
				strncpy(lenbuf,(char*)&resultbuff[9],4);
				DWORD	fileLen	= strtol(lenbuf,NULL,16)*512;		//ÿҳΪ512ֽ
				m_downFileStartFlag	= 1;
				m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,1,0);
			}
		}
		if(Match_Sensor(buff,"#StartErase"))
		{
			KillTimer(8);
			m_dlgMessage.PostMessage(WM_SOLMETAERASE,1,0);
		}
		if(m_downFileStartFlag)
		{
			strcpy(m_szParse,m_szTemp);
			strcat(m_szParse,buff);
//			CString			strReg	= "\n";
			wchar_t			*strReg	= _T("\n");
			split_results spResult;
			REGEX_FLAGS		flag	= GLOBAL | ALLBACKREFS | NOCASE;
//			rpattern		pat((LPCTSTR)strReg,flag);
			rpattern		pat((LPWSTR)strReg,flag);
			wchar_t			wszParse[MAX_PATH];
			MultiByteToWideChar(CP_ACP,0,m_szParse,-1,wszParse,MAX_PATH);
			int icount		= pat.split((LPWSTR)wszParse,spResult);
			char chspresult[MAX_PATH];
			for(int i=0;i<icount;i++)
			{
				KillTimer(7);
				memset(m_szTemp,0,MAX_PATH);
				WideCharToMultiByte (CP_OEMCP,NULL,spResult[i].c_str(),-1,chspresult,MAX_PATH,NULL,FALSE);
				if(Match_Sensor(chspresult,"\\$.+\\*.{2}",m_szTemp)||
					Match_Sensor(chspresult,"\\*.{5}\\*",m_szTemp))
				{
					m_downloadFile.Write(m_szTemp,strlen(m_szTemp));
					m_downloadFile.Write("\r\n",2);
				}
				else
				{
					strncpy(m_szTemp,chspresult,spResult[i].length());
				}
			}
		}		
		if(Match_Sensor(buff,"#downcomplete"))
		{
			m_downloadFile.Close();
			m_downFileOpenFlag	= 0;
			m_downloadFlag		= 0;
			m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,2,0);
		}
		if(Match_Sensor(buff,"#erasecomplete"))
		{
			m_dlgMessage.PostMessage(WM_SOLMETAERASE,2,0);
			m_downloadFlag	= 0;
		}

	}
	else
	{
		if(strncmp(buff,"@lok",4)==0)
		{
			SetTimer(3,10*1000,NULL);		//趨ӳʱʱ
			this->PostMessage(WM_DOWNLOADHEX,0,0);
		}
		else if(strncmp(buff,"@lerror",7)==0)
		{
			SetTimer(3,10*1000,NULL);		//趨ӳʱʱ
			this->PostMessage(WM_DOWNLOADHEX,1,0);
		}
		else if(strncmp(buff,"@LReady",7)==0)
		{
			KillTimer(4);
			KillTimer(5);
			SetTimer(3,10*1000,NULL);
			this->PostMessage(WM_DOWNLOADHEX,0,0);
		}
		else if(strncmp(buff,"@lcomplete",10)==0)
		{
			KillTimer(3);		//ӳʱʱ
			m_hexFile.Close();
			m_openFileFlag	= 0;
			OnBtnComstop();
			m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,3,0);
//			AfxMessageBox(_T("Firmware Upgrade Success!"));
		}
	}	
}

void CCOM32Dlg::OnBtnComstart() 
{
	// TODO: Add your control notification handler code here
	CString strcomname;
	CString strbandrate;
	m_cmb_comlist.GetLBText(m_cmb_comlist.GetCurSel(),strcomname);
	m_bandRate.GetLBText(m_bandRate.GetCurSel(),strbandrate);
	com1->SetCommName(strcomname);
	com1->SetBaudRate(_ttoi(strbandrate));
	if(com1->StartComm())
	{
		m_btn_comstart.EnableWindow(FALSE);
		m_btn_comstop.EnableWindow(TRUE);
	}
}

void CCOM32Dlg::OnBtnComstop() 
{
	// TODO: Add your control notification handler code here
	if(com1->IsOpened())
		com1->StopComm();
	m_btn_comstart.EnableWindow(TRUE);
	m_btn_comstop.EnableWindow(FALSE);
}

void CCOM32Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if(com1->IsOpened())
	{
		com1->StopComm();
	}

	if(m_openFileFlag)
		m_hexFile.Close();
}

void CCOM32Dlg::OnButtonBrowse() 
{
//	CFileDialog	fileDlg(TRUE, "hex", NULL, OFN_OVERWRITEPROMPT,
//						"Hex Files (*.hex)|*.hex|All Files (*.*)|*.*|");
	CFileDialog	fileDlg(TRUE, _T("bin"), NULL, OFN_OVERWRITEPROMPT,
						_T("Bin Files (*.bin)|*.bin|All Files (*.*)|*.*|"));
	if(fileDlg.DoModal()==IDOK)
	{
		m_strPath	= fileDlg.GetPathName();
		GetDlgItem(IDC_EDIT_PATH)->SetWindowText(m_strPath);
	}
	
}

void CCOM32Dlg::OnButtonDownload() 
{
	if(m_openFileFlag)
	{
		m_hexFile.Close();
		m_openFileFlag	= 0;
	}

	if(com1->IsOpened())
		OnBtnComstop();
	m_bandRate.SetCurSel(1);
	OnBtnComstart();
	Sleep(100);
	if(com1->IsOpened())
	{
		m_downloadFlag	= 0;
		if((!m_strPath.IsEmpty())&&m_hexFile.Open(m_strPath,CFile::modeRead))
		{
			m_openFileFlag	= 1;
			m_nFileLen	= m_hexFile.GetLength();
			m_hexFile.SeekToBegin();
//			m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,0,m_nFileLen+2);
			this->PostMessage(WM_DOWNLOADHEX,0,0);
			if(m_dlgUpgrade.DoModal()==IDOK)
			{
			}
		}
		else
		{
			AfxMessageBox(g_LoadString(_T("IDS_OPENFILE_ERR")));	//_T("File Open Fail!")
		}
	}
	else
	{
		AfxMessageBox(g_LoadString(_T("IDS_OPENSERIAL_ERR")));		//_T("Serial not Open!")
	}
}

void CCOM32Dlg::OnDownLoadHex(WPARAM wParam, LPARAM lParam)
{
	UINT fileLen	= 0;
	static reSendCnt	= 0;
	if(com1->IsOpened()&&m_openFileFlag)
	{
		if(wParam==0)
		{
			m_sendErrFlag	= 0;
			if(ReadFileLine(m_TxBuf,&fileLen))
			{
				m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,2,fileLen);
				if(!com1->WriteCommData(m_TxBuf,strlen(m_TxBuf)))
				{
					m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
					AfxMessageBox(g_LoadString(_T("IDS_DATAWRITE_ERR")));		//_T("Data Write to Serial is fail!")
				}
				else
				{
					SetTimer(3,10*1000,NULL);		//趨ӳʱʱ
				}
			}
			else
			{
				m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
				AfxMessageBox(g_LoadString(_T("IDS_READFILE_ERR")));		//_T("Occur a Fail at read file!")
			}
		}
		else if(wParam==1)
		{
			if(m_sendErrFlag++>5)
			{
				m_sendErrFlag	= 0;
				KillTimer(3);
				m_hexFile.Close();
				m_openFileFlag	= 0;
				m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
				AfxMessageBox(g_LoadString(_T("IDS_CRC_ERR")));			//_T("Occur a CRC Fail!")
			}
			if(!com1->WriteCommData(m_TxBuf,strlen(m_TxBuf)))
			{
				m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
				AfxMessageBox(g_LoadString(_T("IDS_DATAWRITE_ERR")));	//_T("Occur a fail at write data to serial!")
			}
		}
		else if(wParam==3)
		{
			m_dlgUpgrade.SendMessage(WM_SOLMETAUPGRADE,1,m_nFileLen+2);
		}
	}
	
}

BOOL CCOM32Dlg::ReadFileLine(char *buf,UINT *len)
{
	BOOL bresult	= TRUE;
	char ctemp	= 0;
	int i=0;
	while(1)
	{
		if(m_openFileFlag&&m_hexFile.Read(&ctemp,1))
		{			
			ctemp	-= 0x4E;
			*(buf+i)	= ctemp;
			i++;
			if(ctemp=='\n')
				break;
		}
		else
		{
			bresult		= FALSE;
			break;
		}
	}
	*len		= i;
	*(buf+i)	= 0;
	
	return bresult;
}


void CCOM32Dlg::OnTimer(UINT nIDEvent)
{
	if(nIDEvent==3)
	{
		KillTimer(3);
		m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
//		AfxMessageBox(_T("connect device timeout!"));
	}
	else if(nIDEvent==4)
	{
		if(com1->IsOpened())
		{			
			if(!com1->WriteCommData(m_szCommand,strlen(m_szCommand)))
			{
				KillTimer(4);
				m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
//				AfxMessageBox(_T("occur a fail at write data!"));
			}
			else
			{
				if(m_openFileFlag ++>5)
				{
					m_hexFile.Close();
					m_openFileFlag	= 0;
					KillTimer(4);
					m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
//					AfxMessageBox(_T("connect device timeout!"));
				}
				else
				{
					SetTimer(4,2*1000,NULL);
					SetTimer(5,3*1000,NULL);
				}
				
			}
		}
		else
		{
			KillTimer(4);
			m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
//			AfxMessageBox(_T("not open serial!"));
		}
	}
	else if(nIDEvent==5)
	{
		KillTimer(4);
		KillTimer(5);
		m_hexFile.Close();
		m_openFileFlag	= 0;
		m_dlgUpgrade.PostMessage(WM_SOLMETAUPGRADE,4,0);
//		AfxMessageBox(_T("connect device timeout!"));
	}
	else if(nIDEvent==7)
	{
		if(!com1->WriteCommData("#down\r\n",7))
		{
			m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,3,0);
//			AfxMessageBox(_T("write data error!"));
		}
		if(m_sendErrFlag++>10)
		{
			KillTimer(7);
			m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,3,0);
//			AfxMessageBox(_T("connect device timeout!"));
		}
	}
	else if(nIDEvent==8)
	{
		KillTimer(8);
		m_dlgMessage.PostMessage(WM_SOLMETAERASE,3,0);
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CCOM32Dlg::OnButtonBrowseData() 
{
	LPMALLOC     pMalloc;
	LPITEMIDLIST pidl;
	TCHAR        szPath [MAX_PATH];    // not used
	BROWSEINFO   bi = { GetSafeHwnd(), NULL, szPath, 
						_T("Select destination folder."), 
						BIF_RETURNONLYFSDIRS, NULL, NULL };

	pidl = SHBrowseForFolder ( &bi );

	if ( NULL != pidl )
	{
		if ( SHGetPathFromIDList ( pidl, szPath ) )
		{
			GetDlgItem(IDC_EDIT_PATH_DATA)->SetWindowText(szPath);
		}

		SHGetMalloc ( &pMalloc );
		pMalloc->Free(pidl);
		pMalloc->Release();
	}
	
}

void CCOM32Dlg::OnButtonDownloadData() 
{
	CString		strPath;
	GetDlgItem(IDC_EDIT_PATH_DATA)->GetWindowText(strPath);
	SYSTEMTIME st;
	GetLocalTime(&st);
	CString strtime;
	strtime.Format(_T("Solmeta_%d%d%d"),st.wYear,st.wMonth,st.wDay);
	strPath	= strPath + _T("\\") + strtime + _T(".txt");
	if(m_downloadFlag)
	{
		m_downloadFile.Close();
		m_downFileOpenFlag	= 0;
	}
	if(com1->IsOpened())
		OnBtnComstop();
	m_bandRate.SetCurSel(0);
	OnBtnComstart();
	Sleep(100);
	m_downFileStartFlag	= FALSE;
	if(m_downloadFile.Open(strPath,CFile::modeReadWrite|CFile::modeCreate,NULL))
	{
		m_downFileOpenFlag	= 1;
		m_downloadFlag	= 1;
		m_sendErrFlag	= 0;
//		if(!com1->WriteCommData("#down\r\n",7))
//			AfxMessageBox(_T("write data error!"));
		this->PostMessage(WM_DOWNLOADFILE,0,0);
		if(m_dlgDownload.DoModal()==IDOK)
		{
		}
	}
	else
	{
		AfxMessageBox(_T("occur a fail at open record file!"));
	}
}

void CCOM32Dlg::OnDownloadFile(WPARAM wParam, LPARAM lParam)
{	
	if(com1->IsOpened())
	{
		if(m_sendErrFlag==0)
			SetTimer(7,1*1000,NULL);
		if(!com1->WriteCommData("#down\r\n",7))
		{
			m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,3,0);
//			AfxMessageBox(_T("write data error!"));
		}
	}
	else
	{
		m_dlgDownload.PostMessage(WM_SOLMETADOWNLOAD,3,0);
//		AfxMessageBox(_T("not open serial!"));
	}
}

void CCOM32Dlg::OnButtonErase() 
{
	if(com1->IsOpened())
		OnBtnComstop();
	m_bandRate.SetCurSel(0);
	OnBtnComstart();
	Sleep(100);
	if(com1->IsOpened())
	{
		m_downloadFlag	= 1;
		if(!com1->WriteCommData("#erase\r\n",8))
		{
			AfxMessageBox(g_LoadString(_T("IDS_DATAWRITE_ERR")));		//_T("write data to serial error!")
		}
		else
		{
			SetTimer(8,3*1000,NULL);
			m_dlgMessage.DoModal();
		}
	}
	else
	{
		AfxMessageBox(g_LoadString(_T("IDS_OPENSERIAL_ERR")));		//_T("not open serial!")
	}	
}

void CCOM32Dlg::OnSelchangeComboBandrate() 
{
//	OnBtnComstop();
//	OnBtnComstart();	
}

void CCOM32Dlg::OnSelchangeComlist() 
{
//	OnBtnComstop();
//	OnBtnComstart();	
}

BOOL CCOM32Dlg::Match_Sensor(const char *sbuf, char *cbuf,char *strResult)
{

	if(sbuf==NULL||cbuf==NULL)
		return	FALSE;
	match_results	mResult;
	REGEX_FLAGS		flag	= GLOBAL | ALLBACKREFS | NOCASE | MULTILINE;
//	rpattern		pat((LPCTSTR)cbuf,flag);
	wchar_t			wsbuf[MAX_PATH],wcbuf[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,sbuf,-1,wsbuf,MAX_PATH);
	MultiByteToWideChar(CP_ACP,0,cbuf,-1,wcbuf,MAX_PATH);
	rpattern		pat((LPWSTR)wcbuf,flag);
	int iGroups		= pat.cgroups();
	match_results::backref_type		br	= pat.match((LPWSTR)wsbuf,mResult);//
	
	if((strResult!=NULL)&&br.matched)
	{
		char chmresult[MAX_PATH];
		WideCharToMultiByte(CP_OEMCP,NULL,mResult.backref(0).str().c_str(),-1,chmresult,MAX_PATH,NULL,FALSE);
		strcpy(strResult,chmresult);
	}

	return br.matched;
}

void CCOM32Dlg::OnButtonVer() 
{
	if(com1->IsOpened())
		OnBtnComstop();
	m_bandRate.SetCurSel(0);
	OnBtnComstart();
	m_downloadFlag	= 1;
	if(com1->IsOpened())
		com1->WriteCommData("#ver\r\n",6);	
}


void CCOM32Dlg::LoadAllLanguage()
{
	CString szKey = _T("Language"),szSection = _T("Setting");
	
	CFileFind find;
	bool ret = find.FindFile(g_szCurPath + _T("Language\\*.ini"));
	while(ret)
	{
		ret = find.FindNextFile();
		if(find.IsDots() || find.IsDirectory()) continue;
		
		CString szValue;
		DWORD dwSize = 100;
		if(GetPrivateProfileString(szSection,szKey,_T(""),
			szValue.GetBuffer(dwSize),dwSize,find.GetFilePath()) != 0)
		{
			m_cmbLang.AddString(szValue);
		}
		szValue.ReleaseBuffer();
	}
	find.Close();

	DWORD dwSize = 100;
	CString szLang;
	GetPrivateProfileString(szSection,szKey,_T("English"),szLang.GetBuffer(dwSize),dwSize,g_szSettingPath);
	szLang.ReleaseBuffer();

	m_cmbLang.SelectString(-1,szLang);
}

void CCOM32Dlg::OnSelchangeComboLanguage() 
{
	CString szValue;
	m_cmbLang.GetLBText(m_cmbLang.GetCurSel(),szValue);
	((CCOM32App*)AfxGetApp())->LoadLanguage(szValue);

	//ˢ¶Իʾ
	g_SetDialogStrings(this,IDD);
	Invalidate(false);
	
}
