// DlgMessage.cpp : implementation file
//

#include "stdafx.h"
#include "COM32.h"
#include "DlgMessage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMessage dialog
UINT WM_SOLMETAERASE	= RegisterWindowMessage(_T("SOLMETA ERASE MEMORY MESSAGE"));

CDlgMessage::CDlgMessage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMessage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMessage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgMessage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMessage)
	DDX_Control(pDX, IDC_PROGRESS_ERASEPLAN, m_progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgMessage, CDialog)
	//{{AFX_MSG_MAP(CDlgMessage)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_OK, OnButtonOk)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_SOLMETAERASE,OnEraseMessage)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMessage message handlers

BOOL CDlgMessage::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_uProgressCnt	= 0;
	m_progress.SetRange(0,12);
	m_progress.SetPos(m_uProgressCnt);
	SetTimer(3,200,NULL);
	m_dwTimeCnt	= 0;
	_stprintf(m_szTime,_T("%02d:%02d:%02d"),0,0,0);
	GetDlgItem(IDC_STATIC_ERASETIME)->SetWindowText(m_szTime);
	
	g_SetDialogStrings(this,IDD);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgMessage::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(3);
	
	CDialog::OnClose();
}

void CDlgMessage::OnTimer(UINT nIDEvent) 
{
	static DWORD timecnt	= 0;
	if(nIDEvent==3)
	{
		m_uProgressCnt	= (++m_uProgressCnt)%12;
		m_progress.SetPos(m_uProgressCnt);
		timecnt	= (++timecnt)%5;
		if(timecnt==0)
		{
			m_dwTimeCnt ++;
			int isec	= m_dwTimeCnt%60;
			int imin	= ((m_dwTimeCnt-isec)/60)%60;
			int ihour	= (m_dwTimeCnt-imin*60-isec)/3600;
			_stprintf(m_szTime,_T("%02d:%02d:%02d"),ihour,imin,isec);
			GetDlgItem(IDC_STATIC_ERASETIME)->SetWindowText(m_szTime);
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CDlgMessage::OnEraseMessage(WPARAM wParam, LPARAM lParam)
{
	if(wParam==1)
	{
		GetDlgItem(IDC_STATIC_ERASETEXT)->SetWindowText(g_LoadString(_T("IDS_DLGERASE_STATUS")));	//_T("Erasing Memory ......")
	}
	else if(wParam==2)
	{
		KillTimer(3);
		GetDlgItem(IDC_STATIC_ERASETEXT)->SetWindowText(g_LoadString(_T("IDS_DLGERASE_COMPLETED")));	//_T("Erase Memory Completed!")
		int ilow,iupper;
		m_progress.GetRange(ilow,iupper);
		m_progress.SetPos(iupper);
		GetDlgItem(IDC_BUTTON_OK)->EnableWindow(TRUE);
	}
	else if(wParam==3)
	{
		KillTimer(3);
		GetDlgItem(IDC_STATIC_ERASETEXT)->SetWindowText(g_LoadString(_T("IDS_DLGERASE_TIMEOUT")));	//_T("Connect Device Timeout!")
		GetDlgItem(IDC_BUTTON_OK)->EnableWindow(TRUE);
	}
}

void CDlgMessage::OnButtonOk() 
{
	this->PostMessage(WM_CLOSE,0,0);	
}
